package wrapper;

/**Data structure that contains which estimates are required and then gets filled
   with the required estimates. */
public class Estimates {
  /**Cost estimation for execution time is required by client*/
  public boolean timeRequired = false;
  /**Cost estimation for fee is required by clien*/
  public boolean feeRequired = false;
  /**Cost estimation for data volume is required by clien*/
  public boolean datavolumeRequired = false;
  /**Value for execution time estimation is provided by megamodule*/
  public boolean timeProvided = false;
  /**Value for fee estimation is provided by megamodule*/
  public boolean feeProvided = false;
  /**Value for data volume estimation is provided by megamodule*/
  public boolean datavolumeProvided = false;
  /**Estimated value for execution time*/
  public int timeValue = -1;
  /**Estimated value for fee*/
  public int feeValue = -1;
  /**Estimated value for data volume*/
  public int datavolumeValue = -1;
  /**Accuracy of the value for execution time*/
  public double timeAccuracy = 0;
  /**Accuracy of the value for fee*/
  public double feeAccuracy = 0;
  /**Accuracy of the value for data volume*/
  public double datavolumeAccuracy = 0;
}

