
package wrapper;

/**Contains status information for a result parameter.*/
public class ResultStatus {
  /**Name of the parameter.*/
  final public String name;
  /**InvocationId of the invocation to which this result status belongs.*/ 
  final public Integer invocationId;
  /**Status of the result. Possible values are: <br>
*   NOT_DONE (no result yet available),<br>
*   PARTIAL (some result available, is not yet final result),<br>
*   DONE (final result available) */
  public String status = "NOT_DONE";
  /*Accuracy of the result. Normally this is only relevant if the status of the 
    result is PARTIAL, though a megamodule may also provide accuracy information 
    for final results (see CHAIMS repository information if this value contains
    a valid information in case of status DONE).*/
  public float accuracy = 0;
 
  public ResultStatus(String name, Integer invocationId) {
    this.name = name;
    this.invocationId = invocationId;
  }

} 
  